Index: /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/BaseDao.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/BaseDao.cs	(revision 4049)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/BaseDao.cs	(revision 4050)
@@ -14,6 +14,5 @@
     }
 
-    protected void CommitChanges() {
-      //TODO: DoWhile
+    protected void CommitChanges() {      
       try {
         Context.SubmitChanges(ConflictMode.ContinueOnConflict);
Index: /branches/3.2/sources/HeuristicLab.PluginInfrastructure/Sandboxing/SandboxManager.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.PluginInfrastructure/Sandboxing/SandboxManager.cs	(revision 4049)
+++ /branches/3.2/sources/HeuristicLab.PluginInfrastructure/Sandboxing/SandboxManager.cs	(revision 4050)
@@ -66,5 +66,5 @@
       #region permission set for sandbox
       //Uncomment code for sandboxed appdomain
-      pset = new PermissionSet(PermissionState.None);
+     /* pset = new PermissionSet(PermissionState.None);
       pset.AddPermission(new SecurityPermission(SecurityPermissionFlag.Execution));
       pset.AddPermission(new ReflectionPermission(ReflectionPermissionFlag.AllFlags));
@@ -78,10 +78,10 @@
       }
 
-      pset.AddPermission(fPerm);
+      pset.AddPermission(fPerm);*/
       #endregion
 
       #region permission set of unrestricted appdomain
       // unrestricted appdomain 
-      //pset = new PermissionSet(PermissionState.Unrestricted);
+      pset = new PermissionSet(PermissionState.Unrestricted);
       #endregion
 
Index: /branches/3.2/sources/HeuristicLab.Tracing/3.2/HeuristicLab.Hive.log4net.xml
===================================================================
--- /branches/3.2/sources/HeuristicLab.Tracing/3.2/HeuristicLab.Hive.log4net.xml	(revision 4049)
+++ /branches/3.2/sources/HeuristicLab.Tracing/3.2/HeuristicLab.Hive.log4net.xml	(revision 4050)
@@ -64,5 +64,5 @@
       <threshold value="DEBUG"/>
     </evaluator>
-    <appender-ref ref="ServertRollingFileAppender" />
+    <appender-ref ref="ServerRollingFileAppender" />
   </appender>
   
Index: /branches/3.2/sources/HeuristicLab.Tracing/3.2/HeuristicLab.Tracing-3.2.csproj
===================================================================
--- /branches/3.2/sources/HeuristicLab.Tracing/3.2/HeuristicLab.Tracing-3.2.csproj	(revision 4049)
+++ /branches/3.2/sources/HeuristicLab.Tracing/3.2/HeuristicLab.Tracing-3.2.csproj	(revision 4050)
@@ -88,7 +88,8 @@
   <ItemGroup>
     <None Include="HeuristicLabTracingPlugin.cs.frame" />
-    <Compile Include="HiveLogger.cs" />
     <Compile Include="Logger.cs" />
     <Compile Include="HeuristicLabTracingPlugin.cs" />
+    <Compile Include="MethodCallPatternConverter.cs" />
+    <Compile Include="MethodCallPatternLayout.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Properties\Settings.Designer.cs">
Index: /branches/3.2/sources/HeuristicLab.Tracing/3.2/MethodCallPatternConverter.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Tracing/3.2/MethodCallPatternConverter.cs	(revision 4050)
+++ /branches/3.2/sources/HeuristicLab.Tracing/3.2/MethodCallPatternConverter.cs	(revision 4050)
@@ -0,0 +1,20 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using log4net.Util;
+using System.Diagnostics;
+
+namespace HeuristicLab.Tracing {
+  class MethodCallPatternConverter: PatternConverter {
+    protected override void Convert(System.IO.TextWriter writer, object state) {
+      StackTrace callStack = new StackTrace();
+      int i = 1;
+      while (i <= callStack.FrameCount && !callStack.GetFrame(i).GetMethod().DeclaringType.FullName.StartsWith("HeuristicLab.Hive")) {
+        i++; 
+      }
+      StackFrame stack = new StackFrame(i);      
+      writer.Write(stack.GetMethod().Name);            
+    }
+  }
+}
Index: /branches/3.2/sources/HeuristicLab.Tracing/3.2/MethodCallPatternLayout.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Tracing/3.2/MethodCallPatternLayout.cs	(revision 4050)
+++ /branches/3.2/sources/HeuristicLab.Tracing/3.2/MethodCallPatternLayout.cs	(revision 4050)
@@ -0,0 +1,17 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using log4net.Layout;
+using log4net.Util;
+
+namespace HeuristicLab.Tracing {
+  class MethodCallPatternLayout: PatternLayout {
+    protected override PatternParser CreatePatternParser(string pattern) {
+       PatternParser pp = base.CreatePatternParser(pattern);
+      pp.PatternConverters["RM"] = typeof (MethodCallPatternConverter);
+      return pp;
+      
+    }
+  }
+}
Index: /branches/3.2/sources/HeuristicLab.Tracing/3.2/Properties/Settings.Designer.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Tracing/3.2/Properties/Settings.Designer.cs	(revision 4049)
+++ /branches/3.2/sources/HeuristicLab.Tracing/3.2/Properties/Settings.Designer.cs	(revision 4050)
@@ -2,5 +2,5 @@
 // <auto-generated>
 //     This code was generated by a tool.
-//     Runtime Version:2.0.50727.3074
+//     Runtime Version:2.0.50727.4927
 //
 //     Changes to this file may cause incorrect behavior and will be lost if
@@ -26,5 +26,5 @@
         [global::System.Configuration.UserScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("")]
+        [global::System.Configuration.DefaultSettingValueAttribute("HeuristicLab.Hive.log4net.xml")]
         public string TracingLog4netConfigFile {
             get {
Index: /branches/3.2/sources/HeuristicLab.Tracing/3.2/Properties/Settings.settings
===================================================================
--- /branches/3.2/sources/HeuristicLab.Tracing/3.2/Properties/Settings.settings	(revision 4049)
+++ /branches/3.2/sources/HeuristicLab.Tracing/3.2/Properties/Settings.settings	(revision 4050)
@@ -4,5 +4,5 @@
   <Settings>
     <Setting Name="TracingLog4netConfigFile" Type="System.String" Scope="User">
-      <Value Profile="(Default)" />
+      <Value Profile="(Default)">HeuristicLab.Hive.log4net.xml</Value>
     </Setting>
   </Settings>
Index: /branches/3.2/sources/HeuristicLab/HeuristicLab.csproj
===================================================================
--- /branches/3.2/sources/HeuristicLab/HeuristicLab.csproj	(revision 4049)
+++ /branches/3.2/sources/HeuristicLab/HeuristicLab.csproj	(revision 4050)
@@ -124,5 +124,5 @@
     <None Include="CreateConsoleApplication.cmd" />
     <None Include="CustomPostBuild.cmd" />
-    <None Include="CopyAssemblies.cmd" />
+    <None Include="Resources\CopyAssemblies.cmd" />
     <None Include="CustomPostBuildTemplate_UpdateLocalInstallation.cmd" />
     <None Include="MergeConfigs.cmd" />
Index: /branches/3.2/sources/HeuristicLab/app.config
===================================================================
--- /branches/3.2/sources/HeuristicLab/app.config	(revision 4049)
+++ /branches/3.2/sources/HeuristicLab/app.config	(revision 4050)
@@ -1,6 +1,12 @@
 <?xml version="1.0" encoding="utf-8" ?>
 <configuration>
-    <configSections>      
-      <sectionGroup name="applicationSettings" type="System.Configuration.ApplicationSettingsGroup, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" >
+
+
+  <configSections>
+    <sectionGroup name="spring">
+      <section name="context" type="Spring.Context.Support.ContextHandler, Spring.Core"/>
+      <section name="objects" type="Spring.Context.Support.DefaultSectionHandler, Spring.Core"/>
+    </sectionGroup>
+        <sectionGroup name="applicationSettings" type="System.Configuration.ApplicationSettingsGroup, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" >
             <section name="HeuristicLab.Properties.Settings" type="System.Configuration.ClientSettingsSection, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" requirePermission="false" />          
         </sectionGroup>
@@ -8,8 +14,31 @@
   <connectionStrings>
   </connectionStrings>
+  <!--<system.diagnostics>
+    <sources>
+      <source name="System.ServiceModel.MessageLogging">
+        <listeners>
+          <add name="messages"
+          type="System.Diagnostics.XmlWriterTraceListener"
+          initializeData="c:\logs\messages.svclog" />
+        </listeners>
+      </source>
+    </sources>
+  </system.diagnostics>-->
+
+
   <system.serviceModel>
+    <!--<diagnostics>
+      <messageLogging
+           logEntireMessage="true"
+           logMalformedMessages="false"
+           logMessagesAtServiceLevel="true"
+           logMessagesAtTransportLevel="false"
+           maxMessagesToLog="30000"
+           maxSizeOfMessageToLog="2000"/>
+    </diagnostics> -->
+
   </system.serviceModel>
   <runtime>
-    <gcServer enabled="true"/>
+    <gcServer enabled="false"/>
   </runtime>
   
@@ -32,4 +61,37 @@
     </HeuristicLab.Properties.Settings>
   </applicationSettings>
-  
+  <spring>
+
+    <context>
+      <resource uri="config://spring/objects"/>
+    </context>
+
+    <objects xmlns="http://www.springframework.net"
+         xmlns:aop="http://www.springframework.net/aop">
+      <object id="clientFacade" singleton="false"
+              type="HeuristicLab.Hive.Server.Core.ClientFacade, HeuristicLab.Hive.Server.Core-3.2" />
+
+      <object id="executionEngineFacade" singleton="false"
+              type="HeuristicLab.Hive.Server.Core.ExecutionEngineFacade, HeuristicLab.Hive.Server.Core-3.2" />
+
+      <object id="serverConsoleFacade" singleton="false"
+              type="HeuristicLab.Hive.Server.Core.ServerConsoleFacade, HeuristicLab.Hive.Server.Core-3.2" />
+
+      <object id="serviceOperation" type="Spring.Aop.Support.SdkRegularExpressionMethodPointcut, Spring.Aop">
+        <property name="patterns">
+          <list>
+            <value>HeuristicLab.Hive.Server.Core.ClientFacade.*</value>
+            <value>HeuristicLab.Hive.Server.Core.ExecutionEngineFacade.*</value>
+            <value>HeuristicLab.Hive.Server.Core.ServerConsoleFacade.*</value>
+          </list>
+        </property>
+      </object>
+
+      <object id="sci" type="HeuristicLab.Hive.Server.ServiceCallInterception, HeuristicLab.Hive.Server-3.2" />
+
+      <aop:config>
+        <aop:advisor pointcut-ref="serviceOperation" advice-ref="sci"/>
+      </aop:config>
+    </objects>
+  </spring>
 </configuration>